/*****************************************************************************
**
**		styler_atr.c
**
******************************************************************************/
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

#include <uf_exit.h>
#include <uf_styler.h>

#include <uf_mb.h>
#include <uf.h> 
#include <uf_ui.h>
#include <uf_defs.h>
#include <uf_attr.h> 
#include <uf_part.h> 
#include <uf_modl.h> 
#include <uf_assem.h> 
#include <uf_object_types.h> 

#include "styler_atr.h"
#include "variables.h"

#define ATR_ERR(line)if(ATR_error){PrintErrorMessage(ATR_error, line);}

#define ATR_CB_COUNT ( 18 + 1 ) 

static UF_STYLER_callback_info_t ATR_cbs[ATR_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, ATR_ATR_EDIT},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, ATR_ok_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB        , 0, ATR_apply_cb},
 {ATR_ACTION_0          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_0_act_cb},
 {ATR_ACTION_1          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_1_act_cb},
 {ATR_ACTION_2          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_2_act_cb},
 {ATR_ACTION_3          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_3_act_cb},
 {ATR_ACTION_4          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_4_act_cb},
 {ATR_ACTION_5          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_5_act_cb},
 {ATR_ACTION_6          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_6_act_cb},
 {ATR_ACTION_7          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_7_act_cb},
 {ATR_ACTION_8          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_8_act_cb},
 {ATR_ACTION_9          , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_9_act_cb},
 {ATR_ACTION_10         , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_10_act_cb},
 {ATR_ACTION_11         , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_11_act_cb},
 {ATR_ACTION_12         , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_12_act_cb},
 {ATR_ACTION_13         , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_13_act_cb},
 {ATR_ACTION_14         , UF_STYLER_ACTIVATE_CB     , 0, ATR_action_14_act_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};


static UF_MB_styler_actions_t actions[] = {
    { "atributers.dlg",  NULL,   ATR_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } 
											};


/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
extern int ATR ( int *response )
{/* return value:  Cansel = 3		OK = 2		Applay = 9     Push Button = 9 */
 /*    "C:\\application\\atr17.dlg"  
\\hp00\\server\\user_tools\\win\\application\\atr17.dlg	
 */
	
	int  error_code = 0;
	char fail_message[133];
	
    if (( error_code = UF_initialize()) != 0 ) 
           return (0);

    if (( error_code = UF_STYLER_create_dialog ( "atr17.dlg",
           ATR_cbs,      ATR_CB_COUNT,	NULL,    response )) != 0 )
		{      
          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          fprintf (prterr, "%s\n", fail_message ); 
		  goto term_atr;
		}
   
	
term_atr:

    UF_terminate();                             
    return (error_code);
}
/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
extern void ufusr_cleanup (void)
{
    return;
}



/**************************************************************************************/
/************************UIStyler Callback Functions***********************************/
/**************************************************************************************/
int ATR_ATR_EDIT ( int dialog_id, void * client_data,
				   UF_STYLER_item_value_type_p_t callback_data)
{/*
	constructor
		       ,   STYLER.
	       ,  
	,       ug_tit[].    ""
	 .
		    " ".

 */
	UF_STYLER_item_value_type_t		data;

     
     if ( UF_initialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG );

	 /*	1	*/	
	 data.item_id = UF_STYLER_DIALOG_INDEX;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = " ";
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}
		
	 data.item_id = ATR_ACTION_0;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[0] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_1;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[1] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_2;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[2] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_3;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[3] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_4;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[4] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_5;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[5] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_6;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[6] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_7;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[7] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}
	 
	 data.item_id = ATR_ACTION_8;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[8] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_9;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[9] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_10;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[10] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_11;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[11] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_12;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[12] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_13;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[13] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}

	 data.item_id = ATR_ACTION_14;
	 data.item_attr = UF_STYLER_LABEL;
	 data.value.string = ug_tit[14] ;
	 ATR_error = UF_STYLER_set_value(dialog_id, &data);
	 if(ATR_error)	{ ATR_ERR(__LINE__); goto term;}



	 UF_STYLER_free_value(&data);

     UF_terminate ();

term:
     return (UF_UI_CB_EXIT_DIALOG); 
   
}

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/ 
int ATR_ok_cb ( int dialog_id,  void * client_data,
				UF_STYLER_item_value_type_p_t callback_data)
{
	
     if ( UF_initialize() != 0)  return ( UF_UI_CB_CONTINUE_DIALOG );

    /*fprintf(prterr,"from  ATR_ok_cb  button_ATR=%d\n", button_ATR);	 */	
     UF_terminate ();
   
    return (UF_UI_CB_EXIT_DIALOG);                           
}

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/ 
int ATR_apply_cb ( int dialog_id,  void * client_data,
				   UF_STYLER_item_value_type_p_t callback_data)
{		     
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

	 /*fprintf(prterr,"from  ATR_apply_cb  button_ATR=%d\n", button_ATR);	 */
	 UF_terminate ();

    return (UF_UI_CB_CONTINUE_DIALOG);  
}/* int ATR_apply_cb */

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_0_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)       return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=0;
	 /*fprintf(prterr,"from  ATR_action_10_act_cb  button_ATR=%d\n", button_ATR);*/
     UF_terminate ();

     return ( UF_UI_CB_EXIT_DIALOG );            
}/*	ATR_action_0_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_1_act_cb ( int dialog_id,  void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)    return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=1;
	 /*fprintf(prterr,"from  ATR_action_1_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();
 
    return ( UF_UI_CB_EXIT_DIALOG ); 
}/*	ATR_action_1_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_2_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=2;
	 /*fprintf(prterr,"from  ATR_action_2_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();
  
    return ( UF_UI_CB_EXIT_DIALOG );  
}/*	ATR_action_3_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_3_act_cb ( int dialog_id,  void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)       return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=3;
	 /*fprintf(prterr,"from  ATR_action_3_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

     return ( UF_UI_CB_EXIT_DIALOG );   
}/*	ATR_action_3_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_4_act_cb ( int dialog_id,  void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)          return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=4;
	 /*fprintf(prterr,"from  ATR_action_4_act_cb  button_ATR=%d\n", button_ATR);*/
     UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );   
}/*	ATR_action_4_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_5_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)          return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=5;
	 /*fprintf(prterr,"from  ATR_action_5_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );   
}/*	ATR_action_5_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_6_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
    if ( UF_initialize() != 0)          return ( UF_UI_CB_CONTINUE_DIALOG );

    button_ATR=6;
	 /*fprintf(prterr,"from  ATR_action_6_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );    
}/*	ATR_action_6_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_7_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)          return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=7;
	 /*fprintf(prterr,"from  ATR_action_7_act_cb  button_ATR=%d\n", button_ATR);*/
     UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );   
}/*	ATR_action_7_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_8_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)       return ( UF_UI_CB_CONTINUE_DIALOG );

    button_ATR=8;
	 /*fprintf(prterr,"from  ATR_action_8_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

   return ( UF_UI_CB_EXIT_DIALOG );              
}/*	ATR_action_8_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_9_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)       return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=9;
	 /*fprintf(prterr,"from  ATR_action_9_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

     return ( UF_UI_CB_EXIT_DIALOG );              
}/*	ATR_action_9_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_10_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     
     if ( UF_initialize() != 0)     return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=10;
	 /*fprintf(prterr,"from  ATR_action_10_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

   return ( UF_UI_CB_EXIT_DIALOG );              
}/*	ATR_action_10_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_11_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)         return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=11;
	 /*fprintf(prterr,"from  ATR_action_11_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

     return ( UF_UI_CB_EXIT_DIALOG );               
}/*	ATR_action_11_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_12_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0)          return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=12;
	 /*fprintf(prterr,"from  ATR_action_12_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );              
}/*	ATR_action_12_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_13_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{     
     if ( UF_initialize() != 0)         return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=13;
	 /*fprintf(prterr,"from  ATR_action_13_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );             
}/*	ATR_action_13_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int ATR_action_14_act_cb ( int dialog_id, void * client_data,
							UF_STYLER_item_value_type_p_t callback_data)
{
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     button_ATR=14;
	 /*fprintf(prterr,"from  ATR_action_14_act_cb  button_ATR=%d\n", button_ATR);*/

     UF_terminate ();

     return ( UF_UI_CB_EXIT_DIALOG );             
}/*	ATR_action_14_act_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
static void PrintErrorMessage( int errorCode, int line)
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( prterr, "%s   line=%d\n", message, line );
    }
}/*	PrintErrorMessage()n */


