/*****************************************************************************
**
**		styler_vvod.c
**
******************************************************************************/
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

#include <uf_exit.h>
#include <uf_styler.h>

#include <uf_mb.h>
#include <uf.h> 
#include <uf_cfi.h> 
#include <uf_ui.h>
#include <uf_defs.h>
#include <uf_attr.h> 
#include <uf_part.h> 
#include <uf_modl.h> 
#include <uf_assem.h> 
#include <uf_object_types.h> 

#include "styler_vvod.h"
#include "variables.h"

#define VVOD_ERR(line)if(VVOD_error){PrintErrorMessage(VVOD_error, line);}

#define VVOD_CB_COUNT ( 4 + 1 ) /* Add 1 for the terminator */
 
static UF_STYLER_callback_info_t VVOD_cbs[VVOD_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, VVOD_EDIT},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, VVOD_ok_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB        , 0, VVOD_apply_cb},
 {VVOD_WIDE_S_0         , UF_STYLER_ACTIVATE_CB     , 0, VVOD_REFRECH},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};


static UF_MB_styler_actions_t actions[] = {
    { "vvod.dlg",  NULL,   VVOD_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};





/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
extern int VVOD ( int *ponse )
{/*	 .
	 ,   STYLER,    .
	    "c:\\application\\vvod17.dlg"
"\\hp00\\server\\user_tools\\win\\application\\vvod17.dlg"
 */
    
    if ( ( VVOD_error = UF_initialize() ) != 0 ) 
           return (0) ;
    
    VVOD_error = UF_STYLER_create_dialog ( "vvod17.dlg",
											VVOD_cbs, VVOD_CB_COUNT, NULL, ponse );
		
	VVOD_ERR(__LINE__);
    UF_terminate();                             
    return (VVOD_error);
}/*	VVOD ()	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int VVOD_EDIT ( int dialog_id, void * client_data, UF_STYLER_item_value_type_p_t callback_data)
{/* constructor 
	  ,    :
	1.    " ".
	2.   -  ,    .
	3. Find the part attribute object for the work part. Once the part attribute
	   object identifier is obtained, it may be used as
	   input to other routines that handle user defined attributes.
       Each part has one and only one part attribute object.
	4.      ,  .   
	         ,    
	   (c   ).
			     -     .
	     C:\\prterr    -  " 	=%s  =%s	
	      	find_flag=1.
	       -   	find_flag=0.
 */
	 int								status=0;
	 char								attribute[132], title[132];
     UF_STYLER_item_value_type_t		data;
	 tag_t								part = NULL_TAG;
	 UF_ATTR_value_t					value;
	 
     if ( UF_initialize() != 0)		return ( UF_UI_CB_CONTINUE_DIALOG );

		find_flag=0;	

		/*	1	*/	
		data.item_id = UF_STYLER_DIALOG_INDEX;
		data.item_attr = UF_STYLER_LABEL;
		data.value.string = " ";
		VVOD_error = UF_STYLER_set_value(dialog_id, &data);
		VVOD_ERR(__LINE__);
		
		/*  2
			    .
			     ITEM    STYLER,  
			  data.item_id  .
		*/
		/*fprintf(prterr,"	from  constructor VVOD_EDIT  button_ATR=%d\n", button_ATR);*/

		data.item_id = "WIDE_S_0";	
		data.item_attr = UF_STYLER_LABEL;
		data.value.string = ug_tit[button_ATR] ;		
		VVOD_error = UF_STYLER_set_value(dialog_id, &data);
		VVOD_ERR(__LINE__);
			
		/* 3 */
		VVOD_error = UF_ATTR_ask_part_attribute(&part);
		VVOD_ERR(__LINE__);
	
		/* 4 */		
		do
		{
			value.type = UF_ATTR_string;
			value.value.string = attribute;
			VVOD_error = UF_ATTR_cycle(part, &status, UF_ATTR_string, title, &value);
			VVOD_ERR(__LINE__);
			save_part=part;
			if(status)
			{
			 if(strcmp(title, iman_tit[button_ATR]) == 0)
				{	find_flag=1;
					/*fprintf(prterr," 	=%s  =%s  \n", title, attribute);*/
					data.item_id = "WIDE_S_0";	
					data.item_attr = UF_STYLER_VALUE;
					data.value.string = attribute;
					VVOD_error = UF_STYLER_set_value(dialog_id, &data);
					VVOD_ERR(__LINE__);
					break;
				}
			}
		}while(status != 0);
		
		UF_STYLER_free_value(&data);
	 
	    UF_terminate ();
    
    return ( UF_UI_CB_EXIT_DIALOG );     
}/*	VVOD ()	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int VVOD_ok_cb ( int dialog_id, void * client_data, UF_STYLER_item_value_type_p_t callback_data)
{/*
		   "OK".
		  "OK" -  ,       
	  .
		   ,     
	.     Kontrol().     
	 -  "OK"  "Enter"       
	.   "Cansel"      -    
	.
		   UF_ATTR_assign   C:\\prterr  
	" 	   = ."  	
	"     = ."
 */
	 int								i;
     char								at[132];
     UF_STYLER_item_value_type_t		data;
	 tag_t								part = NULL_TAG;
	 UF_ATTR_value_t					value;
	 
    if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

	/*fprintf(prterr,"from  VVOD_ok_cb  \n");*/
	
	data.item_id = "WIDE_S_0";
	data.item_attr = UF_STYLER_VALUE;

	VVOD_error =  UF_STYLER_ask_value ( dialog_id, &data );
	VVOD_ERR(__LINE__);

	strcpy(at, data.value.string);
	value.value.string=at;
	value.type = UF_ATTR_string; 
	
	if(button_ATR==1) 
	{
		i=Kontrol(at);
		if(i==1)	return (UF_UI_CB_CONTINUE_DIALOG);  
	}

	if(find_flag==1)
		{
			VVOD_error = UF_ATTR_assign (save_part, iman_tit[button_ATR], value);
			if(VVOD_error==0)	
					{fprintf(prterr,"  %s=%s \n", ug_tit[button_ATR], value.value.string);	}
				else	VVOD_ERR(__LINE__);	
		}
		else
			{
				VVOD_error = UF_ATTR_assign (save_part, iman_tit[button_ATR], value);
				if(VVOD_error==0)
						{fprintf(prterr,"   %s=%s \n", ug_tit[button_ATR], value.value.string);	}					
					else	VVOD_ERR(__LINE__);
			}

	UF_terminate ();
	return (UF_UI_CB_EXIT_DIALOG);                           			
}/*	VVOD_ok_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int VVOD_apply_cb ( int dialog_id, void * client_data, UF_STYLER_item_value_type_p_t callback_data)
{/*   
	   "Applay" -     .
 */      	 
    if ( UF_initialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG );

	/*fprintf(prterr,"from  VVOD_apply_cb  \n");*/
	
    UF_terminate ();
  
    return ( UF_UI_CB_CONTINUE_DIALOG );  
}/*	VVOD_apply_cb	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int VVOD_REFRECH ( int dialog_id, void * client_data, UF_STYLER_item_value_type_p_t callback_data)
{/*
		   "Enter".
		   ,     "OK":
	 ,         .
		   UF_ATTR_assign   C:\\prterr  
	" 	   = ."  	
	"     = ."
 */
     int								i;
	 int								status = 0;
	 char								at[132];
     UF_STYLER_item_value_type_t		data;
	 tag_t								part = NULL_TAG;
	 UF_ATTR_value_t					value;
	 
    if ( UF_initialize() != 0)      return ( UF_UI_CB_CONTINUE_DIALOG );

	/* fprintf(prterr,"from  VVOD_REFRECH  \n"); */
	
	data.item_id = "WIDE_S_0";
	data.item_attr = UF_STYLER_VALUE;

	VVOD_error =  UF_STYLER_ask_value ( dialog_id, &data );
	VVOD_ERR(__LINE__);

	strcpy(at, data.value.string);
	value.value.string=at;
	value.type = UF_ATTR_string; 

	if(button_ATR==1) 
	{
		i=Kontrol(at);
		if(i==1)	return (UF_UI_CB_CONTINUE_DIALOG);  
	}

	if(find_flag==1)
		{
			VVOD_error = UF_ATTR_assign (save_part, iman_tit[button_ATR], value);
			if(VVOD_error==0)	
					{fprintf(prterr,"  %s=%s \n", ug_tit[button_ATR], value.value.string);	}
				else	VVOD_ERR(__LINE__);	
		}
		else
			{
				VVOD_error = UF_ATTR_assign (save_part, iman_tit[button_ATR], value);
				if(VVOD_error==0)
						{fprintf(prterr,"   %s=%s \n", ug_tit[button_ATR], value.value.string);	}					
					else	VVOD_ERR(__LINE__);
			}

    UF_terminate ();

    return ( UF_UI_CB_EXIT_DIALOG );    
}/*	VVOD_REFRECH	*/

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
static void PrintErrorMessage( int errorCode, int line)
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( prterr, "%s   line=%d\n", message, line );
    }
}/*	PrintErrorMessage() */


/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
int Kontrol( char *ttt)
{/*
		       .
	    .       
	.    : 0,8888888;  66666,99999.
	 ",8888"  "8888," - .
		   -   0     
	" ".
		   -   1     
	" ".
 */
	char	otar[11] = { '0','1','2','3','4','5','6','7','8','9','.' };
	int		i,j;
	int		pp;
	int sum, flag;
	double num;

	/*fprintf(prterr,"from  Kontrol	ttt=%s\n",	ttt);*/
	
	pp=strlen(ttt);
	sum=0;
	for(j=0; j<pp; j++)
	{	flag=0;
		for(i=0; i<11; i++)
		{	
			if ( (i==0 && ttt[i]==',')  ||  (i==pp-1 && ttt[i]=='.') )
					{ flag=0; break; }
			if(ttt[j] == otar[i])	
					{ flag=1; break; }
		}   			
		if(flag==1)	sum++;
			else	break;
	}
	
	if(sum==pp)
		{	num=atof(ttt);
			fprintf(prterr,"from  Kontrol	 = %f.\n", ttt );
			/*fprintf(prterr,"from  Kontrol	  - %s.\n", ttt ); */
			i=0;	
		}
		else	
		{	/*fprintf(prterr,"from  Kontrol	  - %s.\n", ttt ); */
			i=1;	
		}


	return i;
}/* Kontrol */


