/***************************************************************************** 
** 
**  copy_color_2.c 
** 
**  Description: 
**     Contains Unigraphics entry points for the application. 
**
**  compiled for UNIX by TichonovichEA 8/12/00.
** 
*****************************************************************************/ 
 
/*  Include files */ 
#include <stdio.h> 
#include <uf.h> 
#include <uf_ui.h> 
#include <uf_obj.h> 
#include <uf_object_types.h> 
#include <uf_disp.h> 
#include <uf_modl.h> 
#include "copy_color_2.h" 
 
/***************************************************************************** 
**  Activation Methods 
*****************************************************************************/ 
 
/*  Explicit Activation 
**      This entry point is used to activate the application explicitly, as in 
**      "File->Execute UG/Open->User Function..."
*/ 
extern DllExport void ufusr( char *parm, int *returnCode, int rlen ) 
{ 
		 
		errorCode = UF_initialize(); 
		if(errorCode) 
		{ 
			PrintErrorMessage(errorCode,__LINE__); 
			goto term; 
		} 
		 
/* ******************************************************************************** */
		{/* select solid body */
			char*				message1="Select Parent Solid "; 
			char*				message2="Select Child Solid "; 
			UF_UI_selection_options_t	opts; 
			UF_UI_mask_t			mask; 
			int				response; 
			tag_t				view; 
			double				cursor[3]; 
			int				unhighlight=0; 
 
			opts.other_options=0; 
			opts.reserved=NULL; 
			opts.num_mask_triples=1; 
			opts.mask_triples=&mask; 
 
			opts.mask_triples->object_type=UF_solid_type; 
			opts.mask_triples->object_subtype=0; 
			opts.mask_triples->solid_type=UF_UI_SEL_FEATURE_BODY; 
 
			opts.scope=UF_UI_SEL_SCOPE_WORK_PART; 
 
			 
			select_parent_body: 
			errorCode=UF_UI_select_single(message1,&opts,&response, 
				&parent_solid,cursor,&view); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
 
			switch(response) 
			{ 
				case 1:	/* fprintf(stderr,"user selected BACK=%d  line=%d\n", response,__LINE__); */
						goto select_parent_body; 
 
				case 2:	/* fprintf(stderr,"user selected CANCEL=%d   line=%d\n", response,__LINE__); */
						goto term; 
				case 4: /* fprintf(stderr,"user selected BY_NAME=%d   line=%d\n", response,__LINE__); */
						break; 
				case 5: /* fprintf(stderr,"user selected BY_CURSOR=%d   line=%d\n", response,__LINE__); */
						break; 
			} 
 
 
 
 
			/* ********************************************************** */
 
			/* select_child_body: */
			errorCode=UF_UI_select_single(message2,&opts,&response, 
				&child_solid,cursor,&view); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
 
			switch(response) 
			{ 
				case 1:	fprintf(stderr,"user selected BACK=%d  line=%d\n", 
							response,__LINE__); 
						errorCode=UF_DISP_set_highlight(parent_solid,unhighlight); 
						if(errorCode) 
						{ 
							PrintErrorMessage(errorCode,__LINE__); 
							goto term; 
						} 
						goto select_parent_body; 
 
				case 2:	/* fprintf(stderr,"user selected CANCEL=%d   line=%d\n", response,__LINE__); */
						goto term; 
				case 4: /* fprintf(stderr,"user selected BY_NAME=%d   line=%d\n", response,__LINE__); */
						break; 
				case 5: /* fprintf(stderr,"user selected BY_CURSOR=%d   line=%d\n", response,__LINE__); */
						break; 
			} 
 
 
			errorCode=UF_DISP_set_highlight(child_solid,unhighlight); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
 
			errorCode=UF_DISP_set_highlight(parent_solid,unhighlight); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
 
 
		}/* select solid body */
/* ******************************************************************************** */
/* ******************************************************************************** */
/* ******************************************************************************** */
 
		{/* -----------------ask_body_faces---------------------------------------- */
		 
			errorCode=UF_MODL_ask_body_faces(parent_solid,&parent_face_list); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
			 
			errorCode=UF_MODL_ask_list_count(parent_face_list,&parent_face_count); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
			/* fprintf(stderr,"parent_face_count=%d   line=%d\n", parent_face_count,__LINE__); */
 
			for(i=0;i<parent_face_count;i++) 
				errorCode=UF_MODL_ask_list_item(parent_face_list, i,parent_face_array+i); 
			UF_free(parent_face_list); 
 
 
 
 
			errorCode=UF_MODL_ask_body_faces(child_solid,&child_face_list); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
 
			errorCode=UF_MODL_ask_list_count(child_face_list,&child_face_count); 
			if(errorCode) 
			{ 
				PrintErrorMessage(errorCode,__LINE__); 
				goto term; 
			} 
			 
			/* fprintf(stderr,"child_face_count=%d   line=%d\n", child_face_count,__LINE__); */
			 
			for(i=0;i<child_face_count;i++) 
				errorCode=UF_MODL_ask_list_item(child_face_list, i,child_face_array+i); 
			UF_free(parent_face_list); 
			 
 
 
		}/* -----------------ask_body_faces---------------------------------------- */
/* ******************************************************************************** */
/* ******************************************************************************** */
/* ******************************************************************************** */
		{/* -----------------ask and set display properties------------------------ */
			UF_OBJ_disp_props_t	disp_props; 
			 
			for(i=0;i<parent_face_count;i++) 
			{ 
				errorCode=UF_OBJ_ask_display_properties(parent_face_array[i], &disp_props); 
				if(errorCode) 
				{ 
					PrintErrorMessage(errorCode,__LINE__); 
					goto term; 
				} 
				errorCode=UF_OBJ_set_color(child_face_array[i],disp_props.color); 
				if(errorCode) 
				{ 
					PrintErrorMessage(errorCode,__LINE__); 
					goto term; 
				} 
			} 
 
		}/* -----------------ask and set display properties------------------------ */
		 
		term: 
	        errorCode = UF_terminate(); 
		if(errorCode) 
			PrintErrorMessage( errorCode,__LINE__ ); 
		
} 
/***************************************************************************** 
**  Utilities 
*****************************************************************************/ 
 
/* Unload Handler 
**     This function specifies when to unload your application from Unigraphics. 
**     If your application registers a callback (from a MenuScript item or a 
**     User Defined Object for example), this function MUST return 
**     "UF_UNLOAD_UG_TERMINATE". 
*/ 
extern int ufusr_ask_unload( void ) 
{ 
    return( UF_UNLOAD_IMMEDIATELY ); 
} 
 
/* PrintErrorMessage 
** 
**     Prints error messages to standard error and the Unigraphics status 
**     line.
 */ 
static void PrintErrorMessage( int errorCode,int line ) 
{ 
     
        /* Retrieve the associated error message */ 
        char message[133]; 
        UF_get_fail_message( errorCode, message ); 
 
        /* Print out the message */ 
        UF_UI_set_status( message ); 
 
        fprintf( stderr, "%s   line=%d\n", message,line ); 
    
} 
