/*****************************************************************************
**
**  set_dialog_directory.c
**
**  Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/

/*  Include files */
#include <stdio.h>
#include <uf.h>
#include <uf_ui.h>
#include <uf_part.h>
#include <uf_dirpath.h>

#include "set_dialog_directory.h"

/*****************************************************************************
**  Activation Methods
*****************************************************************************/

/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
    /* Initialize the API environment */
    int errorCode = UF_initialize();
	UF_UI_dialog_dir_id_t id=UF_UI_PART_DIR ;
	char * dir_name="D:\\UGS\\";
	char * prompt_string=" ";
	char * title_string=" ";
	char   filter_string[132]="*";
	char * default_name="qwerty.prt";



	int count=3;
	const char * dirs[]={"D:\\MT13110\\","D:\\Distrib\\","D:\\emz120"};
	tag_t retval_tag;
	char	msg[256];
	char	* dir;

    if ( 0 == errorCode )
    {




		errorCode=UF_DIRPATH_create_from_dirs(count,dirs,&retval_tag);
		if(errorCode)
			PrintErrorMessage(errorCode);
		sprintf(msg,"retval_tag=%d\n",retval_tag);
		uc1601(msg,1);


		count=UF_DIRPATH_ask_dir_count (retval_tag);
		sprintf(msg,"count_dir=%d\n",errorCode);
		uc1601(msg,1);





		errorCode=UF_DIRPATH_ask_curr_dir (retval_tag,&dir);
		if(errorCode)
			PrintErrorMessage(errorCode);
		uc1601(dir,1);
		uc1601("ask_curr_dir",1);



		errorCode=UF_DIRPATH_start_dir_iteration (retval_tag);
		if(errorCode)
			PrintErrorMessage(errorCode);
		uc1601("start_dir_iteration",1);	



		errorCode=UF_DIRPATH_ask_next_dir (retval_tag,&dir);
		if(errorCode)
			PrintErrorMessage(errorCode);
		uc1601(dir,1);
		uc1601("ask_next_dir_1",1);		



		count=UF_DIRPATH_ask_dir_count (retval_tag);
		sprintf(msg,"count_dir=%d\n",errorCode);
		uc1601(msg,1);


        /* Terminate the API environment */
        errorCode = UF_terminate();




    }

    /* Print out any error messages */
    PrintErrorMessage( errorCode );
}
/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}

/* PrintErrorMessage
**
**     Prints error messages to standard error and the Unigraphics status
**     line. */
static void PrintErrorMessage( int errorCode )
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );
		uc1601(message,1);

        fprintf( stderr, "%s\n", message );
    }
}
