/***************************************************************************** 
**
**  ask_face_edes.c 
** 
**  Description: 
**     Contains Unigraphics entry points for the application. 
** 
*****************************************************************************/ 
 
/*  Include files */ 
#include <stdio.h> 
#include <uf.h> 
#include <uf_ui.h> 
#include <uf_ui.h> 
#include <uf_object_types.h> 
#include <uf_disp.h> 
#include <uf_modl.h> 
#include <uf_curve.h> 
#include <uf_csys.h> 
#include <uf_mtx.h> 
#include <uf_assem.h> 
 
#include "ask_face_eges.h" 
 
#define PRTERR(line)if(errorCode){PrintErrorMessage(errorCode,line);errorCode=0;goto term;} 
 
/***************************************************************************** 
**  Activation Methods 
*****************************************************************************/ 
 
/*  Explicit Activation 
**      This entry point is used to activate the application explicitly, as in 
**      "File->Execute UG/Open->User Function..." 
*/ 
extern DllExport void ufusr( char *parm, int *returnCode, int rlen ) 
{ 
	fprintf(stderr ,"ask_face_edges has started	line=%d\n",__LINE__); 
 
 
	errorCode=UF_initialize();PRTERR(__LINE__); 
 
	 
 
get_edge: 
	{ 
		char*	message="   "; 
		char*	title="   "; 
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY; 
		int		response; 
		tag_t	object; 
		double	cursor[3]; 
		tag_t	view; 
	 
 
		object=NULL_TAG; 
		errorCode=UF_UI_select_with_single_dialog(message,title,scope,init_face,NULL,&response,&object, 
			cursor,&view);PRTERR(__LINE__); 
		switch(response) 
		{ 
		case UF_UI_BACK: 
						goto get_edge; 
		case UF_UI_CANCEL: 
						fprintf(stderr ,"user select CANCEL   line=%d", 
							__LINE__); 
 
						goto term; 
		case UF_UI_OK:	 
						goto get_edge; 
		 
		case UF_UI_OBJECT_SELECTED: 
						break; 
		case UF_UI_OBJECT_SELECTED_BY_NAME: 
						break; 
 
		} 
 
 
		edge=object; 
 
 
	 
 
 
	} 
 
 
 
 
 
	{	/*returns an array of 3D point coordinates (x,y,z), based on input curve,chordal tolerance, 
		  amgular tolerance, and step tolerance. 
 		*/
		tag_t	curve_id; 
		double	ctol=.1; 
		double	atol=.0; 
		double	stol=.0; 
 
 
 
		curve_id=edge; 
		errorCode=UF_MODL_ask_curve_points(curve_id,ctol,atol,stol,&numpts,&pts);PRTERR(__LINE__); 
		fprintf(stderr ,"numpts=%d		line=%d\n",numpts,__LINE__); 
 
 
 
	} 
 
 
 
 
	{	/*create an arc or a cicle passing through the user specified input points. */
		 
		double	first_point[3]; 
		double	second_point[3]; 
		double	third_point[3]; 
	 
		tag_t	point; 
 
		int	create_flag=1; 
	 
	 
 
		first_point[0]=*(pts+3*0+0); 
		first_point[1]=*(pts+3*0+1); 
		first_point[2]=*(pts+3*0+2); 
		errorCode=UF_CURVE_create_point(first_point,&point);PRTERR(__LINE__); 
 
		second_point[0]=*(pts+3*((int)numpts/2)+0); 
		second_point[1]=*(pts+3*((int)numpts/2)+1); 
		second_point[2]=*(pts+3*((int)numpts/2)+2); 
		errorCode=UF_CURVE_create_point(second_point,&point);PRTERR(__LINE__); 
 
		third_point[0]=*(pts+3*numpts-3); 
		third_point[1]=*(pts+3*numpts-2); 
		third_point[2]=*(pts+3*numpts-1); 
 
		 
		errorCode=UF_CURVE_create_arc_thru_3pts(create_flag,first_point,second_point,third_point, 
			&arc_tag);PRTERR(__LINE__); 
 
 
 
	} 
 
term: 
	errorCode=UF_terminate();PRTERR(__LINE__); 
	PrintErrorMessage(errorCode,__LINE__); 
	fprintf(stderr ,"ask_face_edges has completed	line=%d\n",__LINE__); 
	 
    
} 
/***************************************************************************** 
**  Utilities 
*****************************************************************************/ 
 
/* Unload Handler 
**     This function specifies when to unload your application from Unigraphics. 
**     If your application registers a callback (from a MenuScript item or a 
**     User Defined Object for example), this function MUST return 
**     "UF_UNLOAD_UG_TERMINATE". */ 
extern int ufusr_ask_unload( void ) 
{ 
    return( UF_UNLOAD_IMMEDIATELY ); 
} 
 
/* PrintErrorMessage 
** 
**     Prints error messages to standard error and the Unigraphics status 
**     line. */ 
static void PrintErrorMessage( int errorCode, int line ) 
{ 
    if ( 0 != errorCode ) 
    { 
        /* Retrieve the associated error message */ 
        char message[133]; 
        UF_get_fail_message( errorCode, message ); 
 
        /* Print out the message */ 
        UF_UI_set_status( message ); 
 
        fprintf( stderr , "%s		line=%d\n", message,__LINE__); 
    } 
} 
/******************************************************************************* 
** init function 
********************************************************************************/ 
static int init_face(UF_UI_selection_p_t select, void* user_data) 
{ 
 
	int	num_triples = 3; 
	UF_UI_mask_t mask_triples[]={ 
		UF_spline_type,0,0, 
		UF_solid_type,0,UF_UI_SEL_FEATURE_ANY_EDGE, 
		UF_plane_type,0,UF_UI_SEL_FEATURE_ANY_EDGE, 
		UF_b_surface_type,0,UF_UI_SEL_FEATURE_ANY_EDGE}; 
	if(errorCode=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples, 
		mask_triples)==0) 
		return UF_UI_SEL_SUCCESS; 
	else 
		return UF_UI_SEL_FAILURE; 
 
 
} 
 
 
 
 
 
 
 
