/* for UNIX   for UNIX  
   kiselev_mirror_components 31 january 2000 
   modify by Tihonovich 15.10.01
   parent_part=UF_PART_ask_display_part() => parent_part=UF_ASSEM_ask_work_part()
*/

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<math.h>

#include<uf.h>
#include<uf_modl.h>
#include<uf_ui.h>
#include<uf_obj.h>
#include<uf_object_types.h>
#include<uf_disp.h>
#include<uf_vec.h>
#include<uf_csys.h>
#include<uf_curve.h>
#include<uf_trns.h>
#include<uf_mtx.h>
#include<uf_part.h>
#include<uf_assem.h>

#include "mirror_work_components.h"

int	INITIALIZE()
{		
	time(&start_time);
	
	fprintf(stderr,"\n\n\n");
	fprintf(stderr,"MIRROR_COMPONENTS started\n");
	
	irc=UF_initialize();
	if(irc!=0)	{
		UF_get_fail_message(irc,errmsg);
		fprintf(stderr,"INITIALIZE line=%d \n",__LINE__);
		fprintf(stderr,"UF_initialize tools irc=%d \n",irc);
		fprintf(stderr,"ermsg = %s \n",errmsg);
		return irc;
			}

return 0;			
}

/******************************************************************/
/******************************************************************/
/******************************************************************/
int	TERMINATE()
{

	double	work_time;
	int	min,sec;
	
	{/* UF_DISP_set_highlight ----------------------------------*/
	
	tag_t 	object_id;
	int 	action_switch=0;
	int	i; 

	for(i=0;i<num_COMPONENTS;i++)
	{
		object_id=bag_COMPONENTS[i];
		irc=UF_DISP_set_highlight(object_id,action_switch); 
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"TERMINATE line=%d \n",__LINE__);
			fprintf(stderr,"UF_DISP_set_highlight tools %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
					
		irc=UF_OBJ_delete_object(bag_CSYS_ID[i]);
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"TERMINATE line=%d \n",__LINE__);
			fprintf(stderr,"UF_OBJ_delete_object tools %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}		
				
				
		irc=UF_OBJ_delete_object(bag_CSYS_MIRROR[i]);
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"TERMINATE line=%d \n",__LINE__);
			fprintf(stderr,"UF_OBJ_delete_object tools %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}														
	}
	
	UF_free(bag_COMPONENTS);
	
	irc=UF_OBJ_delete_object(plane_id);
	if(irc!=0)	{
		UF_get_fail_message(irc,errmsg);
		fprintf(stderr,"TERMINATE line=%d \n",__LINE__);
		fprintf(stderr,"UF_OBJ_delete_object tools %d \n",irc);
		fprintf(stderr,"errmsg=%s \n",errmsg);
		return irc;
			}
		
	}/* UF_DISP_set_highlight ----------------------------- end */
	

	irc=UF_terminate();
	if(irc!=0)	{
		UF_get_fail_message(irc,errmsg);
		fprintf(stderr,"TERMINATE line=%d \n",__LINE__);
		fprintf(stderr,"UF_terminate tools %d \n",irc);
		fprintf(stderr,"errmsg=%s \n",errmsg);
		return irc;
			}

	time(&finish_time);	
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(stderr,"MIRROR_COMPONENTS ended  <Work_Time is %u min %u sec> \n",min,sec);
	
return 0;
}

/******************************************************************/
/******************************************************************/
/******************************************************************/

int	SELECT_COMPONENTS()
{
	
	int	i;
	char*	message="SELECT_COMPONENTS_FOR_MIRRORING";
	UF_UI_selection_options_t 	opts;
	int 				response;
	int 				count;
	tag_t* 				object;
	
	UF_UI_mask_t 	mask[1] = {{UF_component_type, 0, 0}};
	
	opts.other_options = 0;
	opts.reserved = NULL;
	opts.num_mask_triples = 1;
	opts.scope = UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
	opts.mask_triples = &mask[0];	
	
	back_select_by_class:
	irc=UF_UI_select_by_class(message,&opts,&response,&count,&object); 
	if(irc!=0)	{
		UF_get_fail_message(irc,errmsg);
		fprintf(stderr,"tools SELECT_COMPONENTS_BY_CLASS line=%d \n",__LINE__);
		fprintf(stderr,"UF_UI_select_by_class %d \n",irc);
		fprintf(stderr,"errmsg=%s \n",errmsg);
		return irc;
			}
			
	switch(response)
	{	
		case 1:	for(i=0;i<count;i++)	
				{
				irc=UF_DISP_set_highlight(object[i],0);
				if(irc!=0)	{
					UF_get_fail_message(irc,errmsg);
					fprintf(stderr,"tools SELECT_COMPONENTS_BY_CLASS line=%d \n",__LINE__);
					fprintf(stderr,"UF_DISP_set_highlight %d \n",irc);
					fprintf(stderr,"errmsg=%s \n",errmsg);
					return irc;
						}
				}
			UF_free(object);
			goto back_select_by_class;
			
		case 2: fprintf(stderr,"SELECT_COMPONENTS_BY_CLASS line=%d \n",__LINE__);
			fprintf(stderr,"UF_UI_select_by_class tools %d \n",response);
			fprintf(stderr,"errmsg = %s \n","Operator selected CANCEL");
			return response;
			
		case 3:
		
			fprintf(stderr,"num_COMPONENTS=count=%d\n",count);			
			bag_COMPONENTS=object;
			num_COMPONENTS=count;
			break;	
	
	}
				
return 0;
}

/******************************************************************/
/******************************************************************/
/******************************************************************/
int	ASK_COMPONENT_DATA()
{
	
	tag_t 	component;
	char 	part_name[MAX_FSPEC_SIZE+1];
	char 	refset_name[MAX_ENTITY_NAME_SIZE+1];
	char 	instance_name[MAX_ENTITY_NAME_SIZE+1];
	double 	origin[3];
	double 	csys_matrix[9];
	double 	transform[4][4];	
	tag_t	matrix_id;
	tag_t	csys_id;
	int	i;
	
	for(i=0;i<num_COMPONENTS;i++)	
	{	/* FOR  num_COMPONENTS -------------*/
		/*	UF_ASSEM_ask_component_data    
						double  origin[ 3 ] Output Position of component 
						double  csys_matrix[ 9 ] Output Coordinate System Matrix 
						double  transform[ 4 ][ 4 ] Output Transformation Matrix 
		  
			   :
			-	 csys_matrix[9](Output Coordinate System Matrix)  matrix_id ;
			-	 origin[3](Position of component == origin for the coordinate system)
				 matrix_id c csys_id. 
		*/
		component=bag_COMPONENTS[i];
		irc=UF_ASSEM_ask_component_data(component,part_name,refset_name,
			instance_name,origin,csys_matrix,transform); 
		if(irc!=0)
		{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ASK_COMPONENET_DATA line=%d \n",__LINE__);
			fprintf(stderr,"UF_ASSEM_ask_component_data %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
		}

		fprintf(stderr,"\n\n");				
		fprintf(stderr,"part_name = %s \n",part_name);
		fprintf(stderr,"refset_name = %s strlen=%d\n",refset_name,strlen(refset_name));
		fprintf(stderr,"instance_name = %s strlen=%d\n",instance_name,strlen(instance_name));
		fprintf(stderr,"origin %6.4f %6.4f %6.4f \n",origin[0],origin[1],origin[2]);
		fprintf(stderr,"\n\n");	
		
		if(strcmp(refset_name,"None")==0)
			strcpy(refset_name,"");

		{/* UF_CSYS_create_matrix-------------------------*/
		
		irc=UF_CSYS_create_matrix(csys_matrix,&matrix_id);
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ASK_COMPONENET_DATA line=%d \n",__LINE__);
			fprintf(stderr,"UF_CSYS_create_matrix %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
		
		}/* UF_CSYS_create_matrix-------------------- end */

		
		{/* UF_CSYS_create_csys---------------------------*/
		
		irc=UF_CSYS_create_csys(origin,matrix_id,&csys_id); 
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ASK_COMPONENET_DATA line=%d \n",__LINE__);
			fprintf(stderr,"UF_CSYS_create_csys %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
		
		bag_CSYS_ID[i]=csys_id;
		fprintf(stderr,"tools i=%d  bag_CSYS_ID[i]=%d \n", i, bag_CSYS_ID[i]);

		}/* UF_CSYS_create_csys---------------------- end */


	}	/* FOR------------*/

return 0;	
}


/******************************************************************/
/******************************************************************/
/******************************************************************/
int	SPECIFY_PLANE()
{				
	char* message="SPECIFY_PLANE";
	int 	mode=-1;	/* Enable ok without default selection */
	int 	display=0;	/* Display temporary plane in all active views */
	int 	response;
	double 	orientation[9];
	double 	origin[3];
	tag_t 	plane_eid;
		
	back_specify_plane:
	irc=UF_UI_specify_plane(message,&mode,display,&response,orientation,
		origin,&plane_eid); 
	if(irc!=0)	{
		UF_get_fail_message(irc,errmsg);
		fprintf(stderr,"tools SPECIFY_PLANE line=%d \n",__LINE__);
		fprintf(stderr,"UF_UI_specify_plane %d \n",irc);
		fprintf(stderr,"errmsg=%s \n",errmsg);
		return irc;
			}
	
	switch(response)	
	{
		case 1: goto back_specify_plane;
		case 2:	
			fprintf(stderr,"tools SPECIFY_PLANE line=%d \n",__LINE__);
			fprintf(stderr,"UF_UI_specify_plane %d \n",response);
			fprintf(stderr,"errmsg=%s \n","Operator selected CANCEL\n");
			return response;
		case 3: break;
	}

	{/* UF5374 Create Plane
		Creates a plane. Plane objects can only be created 
		in the display part (i.e., the work part must be equal 
		to the display part). */
	
	double	rp1[3],rp2[3],rp3[3];
	
	UF_VEC3_copy(origin,rp1);
	UF_VEC3_add(origin,&orientation[0],rp2);
	UF_VEC3_add(origin,&orientation[3],rp3);
	
	FTN(uf5374)(rp1,rp2,rp3,&plane_id);
	if(plane_id==0)	{
		fprintf(stderr,"0 = Unable to create plane\n");
		fprintf(stderr,"tools uf5374 line=%d \n",__LINE__);
		return 5;
			}
	}/* UF5374 Create Plane */
	
	
	{/* UF5946 Mirror through a Line or a Plane -------------------------*/
	 /* Returns a matrix to perform a reflection 
	 		through a line or a plane.---------------------------*/ 

	tag_t	np1;
	int	r3;
		
	np1=plane_id;
	
	FTN(uf5946)(&np1,matrix_mirror,&r3);
	switch(r3)	{
		case 0:	break;
		case 1:	fprintf(stderr,"tools UF5946 Mirror through a Line or a Plane line=%d \n",__LINE__);
			fprintf(stderr,"errmsg=%s \n","1 - Invalid Line Or Plane Object Identifie");
			return r3;
		case 2:	fprintf(stderr,"tools UF5946 Mirror through a Line or a Plane line=%d \n",__LINE__);
			fprintf(stderr,"errmsg=%s \n","2 - Unique Plane Through Line Cannot Be Defined ");
			return r3;
	
			}
			
	}/* UF5946 Mirror through a Line or a Plane -------------------- end */

return 0;
}

/******************************************************************/
/******************************************************************/
/******************************************************************/
int	CREATE_MIRROR_CSYS()
{
	int	i;

	for(i=0;i<num_COMPONENTS;i++)
	{/* UF5947 Transformation ------------------------------------*/
			
		tag_t	np2[1];
		int	ip3=1;
		int	ip4=2;	/* 2 - Copy */
		int	ip5=0;	/* 0 - Original Layer */
		int	ip6=2;  /* Trace Curve Status 2 - Off */
		tag_t	nr7[1];
		tag_t	nr8;
		int	ir9;
		
		np2[0]=bag_CSYS_ID[i];
		
		FTN(uf5947)(matrix_mirror,np2,&ip3,&ip4,&ip5,&ip6,nr7,&nr8,&ir9);
		switch(ir9)
		{
			case 0:	break;
			case 1: fprintf(stderr,"Too Many Or Too Few Entities To Transform \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
			case 2: fprintf(stderr,"Invalid Parameter\n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
		
			case 3: fprintf(stderr,"Invalid Object (Not Alive Or Not Transformable) \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
				
			case 4: fprintf(stderr,"Shear Matrix With Non-shearable Objects In The List\n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 5: fprintf(stderr,"Modeling update error \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
				
			case 6: fprintf(stderr,"Error adding modeling data to copied solid \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 7: fprintf(stderr,"Cannot scale parametric solid \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 8: fprintf(stderr,"Transformation is unsuitable for the object \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 9: fprintf(stderr,"Cannot scale developed curve \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
				
			case 10: fprintf(stderr,"Cannot mirror solid \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 11: fprintf(stderr,"Cannot transform occurrence  \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;		
		}
						
		bag_CSYS_MIRROR[i]=nr7[0];		
		fprintf(stderr,"CREATE_MIRROR_CSYS() i=%d  bag_CSYS_MIRROR[i]=%d \n", i, bag_CSYS_MIRROR[i]);
		
	}/* UF5947 Transformation ------------------------------- end */

return 0;
}	


/******************************************************************/
/******************************************************************/
/******************************************************************/
int	CREATE_ROTATE_CSYS_x()
{
	tag_t 	csys_id;
	tag_t 	matrix_id;
	double 	csys_origin[3];
	double	matrix_values[9];
	int	i;
	
	for(i=0;i<num_COMPONENTS;i++)	
	{
	
		{/* UF_CSYS_ask_csys_info-------------------------*/
		
		csys_id=bag_CSYS_MIRROR[i];
		
		irc=UF_CSYS_ask_csys_info(csys_id,&matrix_id,csys_origin);	
		if(irc!=0)	
				{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools CREATE_ROTATE_CSYS line=%d \n",__LINE__);
			fprintf(stderr,"UF_CSYS_ask_csys_info %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}

		UF_VEC3_copy(csys_origin,orrr);
		
		}/* UF_CSYS_ask_csys_info-------------------- end */
				
			
		{/* UF_CSYS_ask_matrix_values---------------------*/
		
		irc=UF_CSYS_ask_matrix_values(matrix_id,matrix_values);
		if(irc!=0)	
				{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools CREATE_ROTATE_CSYS line=%d \n",__LINE__);
			fprintf(stderr,"UF_CSYS_ask_matrix_values %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
		
		}/* UF_CSYS_ask_matrix_values---------------- end */
		
		
		{/* UF5945 Rotation-------------------------------*/
		
		int	ir5;
		double	rp3=180.0;
		
		FTN(uf5945)(csys_origin,&matrix_values[0],&rp3,
							rotation_matrix,&ir5);
		switch(ir5)	{
			case 0: break;
			case 1: fprintf(stderr,"tools CREATE_ROTATE_CSYS line=%d \n",__LINE__);
				fprintf(stderr,"UF5945 Rotation %d \n",1);
				fprintf(stderr,"errmsg=%s \n","Direction Vector Is A Zero Vector");
				return 1;
				}
		
		}/* UF5945 Rotation-------------------------- end */
		
	
		{/* UF5947 Transformation ------------------------------------*/
		
	
		tag_t	np2[1];
		int	ip3=1;
		int	ip4=2;	/* 2 - Copy */
		int	ip5=0;	/* 0 - Original Layer */
		int	ip6=2;  /* Trace Curve Status 2 - Off */
		tag_t	nr7[1];
		tag_t	nr8;
		int	ir9;
		
		
		np2[0]=bag_CSYS_MIRROR[i];
		
		FTN(uf5947)(rotation_matrix,np2,&ip3,&ip4,&ip5,&ip6,nr7,&nr8,&ir9);
		switch(ir9)	
		{
			case 0:	break;
			case 1: fprintf(stderr,"Too Many Or Too Few Entities To Transform \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;

			case 2: fprintf(stderr,"Invalid Parameter\n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
		
			case 3: fprintf(stderr,"Invalid Object (Not Alive Or Not Transformable) \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
				
			case 4: fprintf(stderr,"Shear Matrix With Non-shearable Objects In The List\n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 5: fprintf(stderr,"Modeling update error \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
				
			case 6: fprintf(stderr,"Error adding modeling data to copied solid \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 7: fprintf(stderr,"Cannot scale parametric solid \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 8: fprintf(stderr,"Transformation is unsuitable for the object \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 9: fprintf(stderr,"Cannot scale developed curve \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;
				
			case 10: fprintf(stderr,"Cannot mirror solid \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;	
				
			case 11: fprintf(stderr,"Cannot transform occurrence  \n");
				fprintf(stderr,"tools UF5947 Transformation line=%d \n",__LINE__);
				return ir9;		
		}
		
		irc=UF_OBJ_delete_object(csys_id);
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ASK_COMPONENET_DATA line=%d \n",__LINE__);
			fprintf(stderr,"UF_OBJ_delete_object %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}			
		
		bag_CSYS_MIRROR[i]=nr7[0];		
				
		}/* UF5947 Transformation ------------------------------- end */
		
	}/* for for for for for for ---------*/
					
return 0;
}


/******************************************************************/
/******************************************************************/
/******************************************************************/
int	ADD_PART_TO_ASSEMBLY()
{
	tag_t 	component;
	char 	part_name[MAX_FSPEC_SIZE+1];
	char 	refset_name[MAX_ENTITY_NAME_SIZE+1];
	char 	instance_name[MAX_ENTITY_NAME_SIZE+1];
	double 	csys_origin[3];
	double 	csys_matrix[9];
	double 	transform[4][4];
	tag_t	matrix_id;
	tag_t	parent_part;
	int	i;		
	int 			layer=0;	/* 0 Means use the work layer */
	tag_t 			instance;
	
	UF_PART_load_status_t 	error_status;
			
	/*parent_part=UF_PART_ask_display_part(); */	
	parent_part=UF_ASSEM_ask_work_part();

	for(i=0;i<num_COMPONENTS;i++)
	{					
		component=bag_COMPONENTS[i];
		irc=UF_ASSEM_ask_component_data(component,part_name,refset_name,
			instance_name,csys_origin,csys_matrix,transform); 
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ADD_PART_TO_ASSEMBLY line=%d \n",__LINE__);
			fprintf(stderr,"UF_ASSEM_ask_component_data %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
				
		if(strcmp(refset_name,"None")==0)
			strcpy(refset_name,"");

		irc=UF_CSYS_ask_csys_info(bag_CSYS_MIRROR[i],&matrix_id,csys_origin); 
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ADD_PART_TO_ASSEMBLY line=%d \n",__LINE__);
			fprintf(stderr,"UF_CSYS_ask_csys_info %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}

		irc=UF_CSYS_ask_matrix_values(matrix_id,csys_matrix);
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ADD_PART_TO_ASSEMBLY line=%d \n",__LINE__);
			fprintf(stderr,"UF_CSYS_ask_csys_info %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
		
		
		irc=UF_ASSEM_add_part_to_assembly(parent_part,part_name,refset_name,instance_name,
			csys_origin,csys_matrix,layer,&instance,&error_status); 
		if(irc!=0)	{
			UF_get_fail_message(irc,errmsg);
			fprintf(stderr,"tools ASK_COMPONENET_DATA line=%d \n",__LINE__);
			fprintf(stderr,"UF_ASSEM_add_part_to_assembly %d \n",irc);
			fprintf(stderr,"errmsg=%s \n",errmsg);
			return irc;
				}
				
		if(error_status.failed)	{
			fprintf(stderr,"tools ASK_COMPONENET_DATA line=%d \n",__LINE__);
			fprintf(stderr,"UF_ASSEM_add_part_to_assembly %d \n",irc);
			fprintf(stderr,"errmsg=%s \n","the load failed and was rolled back");
			return 1;
					}
		
	}	/* for i */						
					

return 0;
}
