/*****************************************************************************
**	for UNIX	UNIX	UNIX	UNIX	UNIX
**  get_wcs_normal_to_face.c
**	
**	Lazovich U.V.
**	Completed by Tihonovich E.A. 03.10.01.
**  Added cycle for return to beginning of work - it is possibility to select new face.
**
**  Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/

/*  Include files */
#include <stdio.h>
#include <stdlib.h>
#include <uf.h>
#include <uf_ui.h>
#include <uf_object_types.h>
#include <uf_disp.h>
#include <uf_modl.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>

#include "get_wcs_normal_to_face.h"

/*****************************************************************************
**  Activation Methods
*****************************************************************************/

/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
   
    fprintf(stderr,"get_wcs_normal_to_face	has STARTED	line=%d\n",__LINE__);


    errorCode = UF_initialize();
    if (errorCode)
    {
		PrintErrorMessage( errorCode,__LINE__ );
		goto term;
    }

/* select_face ------------------------------------------------------------------------*/
select_face:
	{
		char	cue[]=" ";
		char	title[]=" ";
		int		response;
		tag_t	object=NULL_TAG,view;
		double	cursor[3];

		errorCode=UF_UI_select_with_single_dialog(cue,title,UF_UI_SEL_SCOPE_NO_CHANGE,
			init_proc_face,NULL,&response,&object,cursor,&view);
		if(errorCode)
		{
			PrintErrorMessage( errorCode,__LINE__ );
			goto term;
		}

		switch(response)
		{
		case	UF_UI_BACK:	goto select_face;
		case	UF_UI_CANCEL:	fprintf(stderr,"user slected CANCEL	line=%d\n",
						__LINE__);
					goto term;
		case	UF_UI_OK:	goto select_face;
		case	UF_UI_OBJECT_SELECTED:	break;
		case	UF_UI_OBJECT_SELECTED_BY_NAME:	break;
		}
		face_id=object;
	}

/* select_face  -----------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*selection_point_type ----------------------------------------------------------*/
selection_type:
	{
		char*	cp1="   ?";
		int	ip2=1;
		char	cp3[][38]={"  ","  "};
		int	ip4=2;

		errorCode=uc1603(cp1,ip2,cp3,ip4);
		switch(errorCode)
		{
		case	1:	errorCode=UF_DISP_set_highlight(face_id,0);
				if(errorCode)
				{
					PrintErrorMessage( errorCode,__LINE__ );
					goto term;
				}
				goto select_face;
		case	2:	fprintf(stderr,"user selected CANCEL	line=%d\n",__LINE__);
				goto term;
		case	5:	selection_flag=5;
				break;
		case	6:	selection_flag=6;
				break;		
		case	19:	fprintf(stderr,
						"Disallowed state, unable to bring up dialog	line=%d\n",
						__LINE__);
				goto term;
		}
	}
/*selection_point_type ---------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*select_by_one_point ----------------------------------------------------------------*/
if(selection_flag==5)
	{
		int	i;
		char*	cp1="  -  CANCEL";
		int	ia2[]={4,0};
		int	ip3=0;
		double	rr4[3];


		for(i=0;i<1000;i++)
		{
			errorCode=uc1616(cp1,ia2,ip3,rr4);
			switch(errorCode)
			{
			case	1:	UF_DISP_refresh();
					goto selection_type;
			case	2:	points_bag_count=i;
					UF_DISP_refresh();
					goto ask_face_parm;
			case	5:	UF_VEC3_copy(rr4,points_bag[i]);
					break;
			case	7:	fprintf(stderr,"no active part		line=%d\n",__LINE__);
					goto term;
			case	8:	fprintf(stderr,
						"Disallowed state, unable to bring up dialog		line=%d\n",
						__LINE__);
					goto term;
			}
		}
		goto term;
	}
/*select_by_one_point ----------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*select_existing_point_set ----------------------------------------------------------*/
if(selection_flag==6)
	{
		char*	message="   ";
		char*	title="   ";
		int	scope=UF_UI_SEL_SCOPE_WORK_PART_AND_OCC;
		void*	user_data=NULL;
		int	response;
		int	count;
		tag_t*	object;
		int	i;

		errorCode=UF_UI_select_with_class_dialog(message,title,scope,init_proc_point,
			user_data,&response,&count,&object);
		if(errorCode)
		{
			PrintErrorMessage( errorCode,__LINE__ );
			goto term;
		}
		
		switch(response)
		{
		case	UF_UI_BACK:
			for(i=0;i<count;i++)
			{
				errorCode=UF_DISP_set_highlight(object[i],0);
				goto term;
			}
			UF_free(object);
			goto selection_type;
		case	UF_UI_CANCEL:
			fprintf(stderr,"user selected CANCEL	line%d\n",__LINE__);
			goto term;
		case	UF_UI_OK:
			break;
		}

		for(i=0;i<count;i++)
		{
			errorCode=UF_CURVE_ask_point_data(object[i],points_bag[i]);
			if(errorCode)
			{
				PrintErrorMessage( errorCode,__LINE__ );
				goto term;
			}
		}

		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);
			if(errorCode)
			{
				PrintErrorMessage( errorCode,__LINE__ );
				goto term;
			}
		}

		UF_free(object);

		points_bag_count=count;
		goto ask_face_parm;
	}
/*select_existing_point_set ----------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*ask_face_parm ----------------------------------------------------------------------*/
ask_face_parm:
	{
		int	i;

		for(i=0;i<points_bag_count;i++)
		{
			errorCode=UF_MODL_ask_face_parm(face_id,points_bag[i],face_parms_bag[i],
				points_bag[i]);
			if(errorCode)
			{
				PrintErrorMessage( errorCode,__LINE__ );
				goto term;
			}
		}
	}
/*ask_face_parm ----------------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*ask_face_props ---------------------------------------------------------------------*/
{
	int	i;
	double	v1[3],u2[3],v2[3],radii[2];

	for(i=0;i<points_bag_count;i++)
	{
		errorCode=UF_MODL_ask_face_props(face_id,face_parms_bag[i],points_bag[i],
			x_axes_bag[i],v1,u2,v2,unit_norm_bag[i],radii);
		if(errorCode)
		{
			PrintErrorMessage( errorCode,__LINE__ );
			goto term;
		}
	}
}
/*ask_face_props ---------------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*disp_conehead ---------------------------------------------------------------------*/
{
	char*	cp1="  ";
	int	ip2=1;
	char	cp3[][38]={" "," "};
	int	ip4=2;
	int	i;

conehead:
	UF_DISP_refresh();

	for(i=0;i<points_bag_count;i++)
		UF_DISP_conehead(UF_DISP_ALL_VIEWS_BUT_DRAWING,points_bag[i],
	
	unit_norm_bag[i],0);
	errorCode=uc1603(cp1,ip2,cp3,ip4);
	switch(errorCode)
	{
	case	1:	UF_DISP_refresh();
			goto selection_type;
	case	2:	fprintf(stderr,"user selected CANCEL	line=%d\n",__LINE__);
			goto term;
	case	5:	break;
	case	6:	for(i=0;i<points_bag_count;i++)
				{
					UF_VEC3_negate(unit_norm_bag[i],unit_norm_bag[i]);
				}
				UF_DISP_refresh();
				goto conehead;
	case	19:	fprintf(stderr,
				"Disallowed state, unable to bring up dialog	line=%d\n",
				__LINE__);
				goto term;
	}
}
/*disp_conehead ----------------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*build_csys -------------------------------------------------------------------------*/
{
	tag_t	matrix_id;
	double	matrix_values[9];
	tag_t	csys_id;
	int	i;

	for(i=0;i<points_bag_count;i++)
	{
		UF_MTX3_initialize(unit_norm_bag[i],x_axes_bag[i],matrix_values);
		UF_VEC3_copy(&matrix_values[0],unit_norm_bag[i]);
		UF_VEC3_copy(&matrix_values[3],&matrix_values[0]);
		UF_VEC3_copy(&matrix_values[6],&matrix_values[3]);
		UF_VEC3_copy(unit_norm_bag[i],&matrix_values[6]);

		errorCode=UF_CSYS_create_matrix(matrix_values,&matrix_id);
		if(errorCode)
		{
			PrintErrorMessage( errorCode,__LINE__ );
			fprintf(stderr,"i=%d\n",i);
			goto term;
		}
		
		errorCode=UF_CSYS_create_csys(points_bag[i],matrix_id,&csys_id);
		if(errorCode)
		{
			PrintErrorMessage( errorCode,__LINE__ );
			fprintf(stderr,"i=%d\n",i);
			goto term;
		}
	}
}
/*build_csys -------------------------------------------------------------------------*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*new_cycle ----------------------------------------------------------------------*/
{
	char*	cp1="  ?";
	int	ip2=1;
	char	cp3[][38]={" "," "};
	int	ip4=2;


	errorCode=uc1603(cp1,ip2,cp3,ip4);
	switch(errorCode)
	{
	case	1:	/* BACK -        */				
				goto selection_type;
	case	2:	/* fprintf(stderr,"user selected CANCEL  line=%d\n",__LINE__);  */
				goto term;
	case	5:	/*  ; OK */
				errorCode=UF_DISP_set_highlight(face_id,0);
				if(errorCode)
				{
					PrintErrorMessage(errorCode,__LINE__);
					goto term_1;
				}	
				UF_DISP_refresh();
				goto select_face;
				break;
	case	6:	/*  " " */
			goto term;


	}
}
/*new_cycle ----------------------------------------------------------------------*/


term:
/*set_hloff_and_free -----------------------------------------------------------------*/
	{
		errorCode=UF_DISP_set_highlight(face_id,0);
		if(errorCode)
		{
			PrintErrorMessage(errorCode,__LINE__);
			goto term_1;
		}
		UF_DISP_refresh();
	}
/*set_hloff_and_free -----------------------------------------------------------------*/

term_1:
    
	errorCode = UF_terminate();   
	if(errorCode)
	{
		PrintErrorMessage(errorCode,__LINE__);
	}

	fprintf(stderr,"get_wcs_normal_to_face	has FINISHED	line=%d\n",__LINE__);
	

}
/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}

/* PrintErrorMessage
**
**     Prints error messages to standard error and the Unigraphics status
**     line. 
*/
static void PrintErrorMessage( int errorCode, int	line )
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( stderr, "%s\n", message );
    }
}

/* ################################################################################*/
static int init_proc_face(UF_UI_selection_p_t select,void* user_data)
{
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_face_type,0,0};

	errorCode=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples,mask_triples);
	if(errorCode==0)
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}

static int init_proc_point(UF_UI_selection_p_t select,void* user_data)
{
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_point_type,0,0};

	errorCode=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples,mask_triples);
	if(errorCode==0)
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}
